#include <stdio.h>
#include <stdlib.h>

#define nfastsieves 4

typedef struct psvstruct {
  int p;
  int *Vimg;
  int v0img;
  char *L;
} primsieve;

int *scanlist(int lgth) {
  int i, *buf;

  buf = (int*) calloc(lgth,sizeof(int));
  if (lgth==0)
    return buf;
  else if(lgth==1) {
    scanf(" [ %d ]",&buf[0]);
    return buf;
  } else {
    scanf(" [ %d",&buf[0]);
    for (i=1; i<lgth; i++)
      scanf(" , %d",&buf[i]);
    scanf(" ]");
    return buf;
  }
}

void fputlist(FILE *file,int lgth, int *buf) {
  int i;
  if (lgth==0)
    fprintf(file," ");
  else {
    for (i=0; i<lgth; i++)
      fprintf(file,"%d ",buf[i]);
    fprintf(file,"\n");
  }
}

/*****************************************************************************
void fputlist(FILE *file,int lgth, int *buf) {
  int i;

  if (lgth==0)
    fprintf(file,"[]");
  else if (lgth==1)
    fprintf(file,"[%d]",buf[0]);
  else {
    fprintf(file,"[%d",buf[0]);
    for (i=1; i<lgth; i++)
      fprintf(file,",%d",buf[i]);
    fprintf(file,"]");
  }
}
******************************************************************************/
int sgn(float x) {
  return (x<0 ? -1 : (x>0 ? 1 : 0));
}

float saturation(primsieve *psv) {
  int i;
  float res;
  res=0;
  for(i=0;i<(*psv).p;i++)
    if((*psv).L[i]) res+=1;
  return res/(*psv).p;
}

int saturcomp(const void *psv1,const void *psv2) {
  return sgn(saturation((primsieve*)psv1)-saturation((primsieve*)psv2));
}

int main(void) {
  int nV,B,Nps;

  primsieve *psv;
  int i,j,k,*mc,l,ll,flag,lch;
  char c;

  int fsl[nfastsieves+1],fsv1[nfastsieves+1];
  int *fscorr[nfastsieves+1];

  scanf("%d",&nV);
  scanf("%d",&B);
  scanf("%d",&Nps);
  psv = (primsieve*) calloc(Nps,sizeof(primsieve));
  if (Nps<nfastsieves) {
    fprintf(stderr,"Error: Should get at least %d sieves.\n",nfastsieves);
    exit(1);
  }
  for(i=0; i<Nps; i++) {
    scanf("%d",&psv[i].p);
    psv[i].Vimg = (int*)calloc(nV,sizeof(int));
    for(j=0; j < nV; j++)
      scanf("%d",&psv[i].Vimg[j]);
    scanf("%d",&psv[i].v0img);
    psv[i].L = (char*)calloc(psv[i].p,sizeof(char));
    for(j=0; j < psv[i].p; j++) {
      for(c=getchar(); c != '0' && c != '1';c=getchar());
      if (c=='1') psv[i].L[j]=1; else psv[i].L[j]=0;
    }
  }
  qsort(psv, Nps, sizeof(primsieve),saturcomp);
   
/*****************************************************************************
  fprintf(stderr,"Nr of basis vectors:%d\nSearch bound:%d\nNr of primitive sieves:%d\n",
    nV,B,Nps);
  for (i=0; i<Nps; i++) {
    fprintf(stderr,"dump of data for primsieve %d\n---------\n",i);
    fprintf(stderr,"underlying prime:%d\nimage of V:",psv[i].p);
    for (j=0; j<nV; j++)
      fprintf(stderr,"%d ",psv[i].Vimg[j]);
    fprintf(stderr,"\nimage of v0:%d\nbitstring:",psv[i].v0img);
    for (j=0; j<psv[i].p; j++)
      if (psv[i].L[j]) putc('1',stderr); else putc('0',stderr);
    fprintf(stderr,"\n----------\n");
  }
*****************************************************************************/
  //printf("CommLine:=[");

  mc = (int*)calloc(nV+1,sizeof(int));
  for(i=0;i<=nV;i++)
    mc[i]=0;
    
  for(j=0;j<=nfastsieves;j++) {
    fsl[j]=psv[j].v0img;
    fsv1[j]=(psv[j].Vimg[0]%psv[j].p)-psv[j].p;
    fscorr[j]=(int*)calloc(nV,sizeof(int));
    for(i=0;i<nV;i++)
      fscorr[j][i]=((-B*psv[j].Vimg[i]+psv[j].Vimg[i+1])%psv[j].p)-psv[j].p;  
  }  
  lch=0;
  while(lch<nV) {
    flag=1;
    for(j=0;(j<nfastsieves)&&(flag=psv[j].L[fsl[j]]);j++);
    
    for(;flag && (j<Nps);j++) {
      l=psv[j].v0img;
      for(i=0;i<nV;i++) l+=mc[i]*psv[j].Vimg[i];
      flag=psv[j].L[l%psv[j].p];
    }
    if (flag) fputlist(stdout,nV,mc); /*changed for magma: printf(",\n");*/
    for(j=0;j<nfastsieves;j++) {
      fsl[j]+=fsv1[j];
      if (fsl[j]<0) fsl[j]+=psv[j].p;
    }  
    for(lch=0;(++mc[lch])>=B;lch++) {
      mc[lch]=0;
      for(j=0;j<nfastsieves;j++) {
        fsl[j]+=fscorr[j][lch];
        if (fsl[j]<0) fsl[j]+=psv[j].p;
      }
    }      
  }
  // changed for magma: printf("[]];\n");     
  return(0);
}
